D,#TD1PsT[Begin using 006 escapes](0 0 (NIL 0) (NIL NIL NIL) "CPTFONT")(1 0 (NIL 0) (NIL :ITALIC NIL) "CPTFONTI")0;;; -*- Mode: LISP; Package: SYSTEM-INTERNALS; Fonts: CPTFONT,CPTFONTI; Syntax: Common-lisp -*-

; NOT (in-package 'ap5)!

(DEFUN IE-DESCRIBE-slots-CHECK (SYMBOL)
  ;generalizes previous definition of IE-DESCRIBE-ARGUMENTS-CHECK - dga11III86
  (AND (VALIDATE-FUNCTION-SPEC SYMBOL)
       (let ((function-like
	       (OR (FDEFINEDP SYMBOL)
		     (AND (SYMBOLP SYMBOL)
			  (GET SYMBOL 'COMPILED-ONLY-ARGLIST))))
	     (relation-like
	       (or (ap5:relationp SYMBOL)
		   (ap5::cl-type-name symbol)
		   (memq symbol ap5::*update-macro-list*))))
	 (cond
	   ((and function-like relation-like)  :both)
	   (function-like  :function-like)
	   (relation-like  :relation-like)
	   (t  nil)))))


(DEFUN-IE IE-RELEVANT-FUNCTION-OR-MESSAGE-or-relation ()
  ;derived from IE-RELEVANT-FUNCTION - dga11III86
  ;rederived from self and IE-RELEVANT-FUNCTION-OR-MESSAGE - dga21I87
  (LET (SYMBOL CHECK end (message-p nil))
    (DO ((BEGIN (IEB-TYPEIN-POINTER))
	 (READ))
	(NIL)
      (SETQ BEGIN (IE-REVERSE-SEARCH-CHAR #\( BEGIN))
      (IF BEGIN (INCF BEGIN) (RETURN))
      (SETQ END (IE-SEARCH-CHAR #\SPACE BEGIN))
      (CONDITION-CASE (ERROR)
	  (PROGN
	    ;; First try looking in the current package.
	    (SETQ READ (IE-READ-FROM-BUFFER BEGIN END 'INTERN-SOFT))
	    (IF READ
		(COND ((setq check (IE-DESCRIBE-slots-CHECK READ))
		       (SETQ SYMBOL READ)
		       (WHEN (AND (NOT (NULL END))
				  (MEMQ SYMBOL '(SEND LEXPR-SEND FUNCALL LEXPR-FUNCALL
						 FUNCALL-SELF LEXPR-FUNCALL-SELF)))
			 ;; Try to find the message
			 (CONDITION-CASE ()
			      (MULTIPLE-VALUE-BIND (MESSAGE POSITION)
				  (IE-READ-FROM-BUFFER END (IEB-TYPEIN-POINTER) 'INTERN-SOFT)
				(UNLESS (MEMQ SYMBOL '(FUNCALL-SELF LEXPR-FUNCALL-SELF))
				  (MULTIPLE-VALUE (MESSAGE POSITION)
				    (IE-READ-FROM-BUFFER POSITION (IEB-TYPEIN-POINTER)
							 'INTERN-SOFT)))
				(WHEN (OR (KEYWORDP MESSAGE)
					  (AND (LISTP MESSAGE)
					       (EQ (CAR MESSAGE) 'QUOTE)
					       (SETQ MESSAGE (CADR MESSAGE))
					       (SYMBOLP MESSAGE)))
				  (WHEN (FLAVOR:FIND-GENERIC-FUNCTION MESSAGE NIL)
				    (SETQ SYMBOL MESSAGE
					  MESSAGE-P T))))
			    (SYS:READ-ERROR)))
		       (RETURN))
		      ((NOT CHECK)
		       (SETQ SYMBOL READ CHECK :READ))))
	    ;; Then try in the toplevel package.
	    (WHEN (NEQ PACKAGE *INPUT-EDITOR-PACKAGE*)
	      (SETQ READ
		    (LET ((PACKAGE *INPUT-EDITOR-PACKAGE*))
		      (IE-READ-FROM-BUFFER BEGIN END 'INTERN-SOFT)))
	      (IF READ
		  (COND ((setq check (IE-DESCRIBE-slots-CHECK READ))
			 (SETQ SYMBOL READ)
			 (RETURN))
			((NOT CHECK)
			 (SETQ SYMBOL READ CHECK :READ)))))
	    ;; Haven't found a symbol which is already interned, so make one
	    ;; for purposes of printing an error message.  Try not to intern
	    ;; any symbols which weren't already there.
	    (UNLESS CHECK
	      (SETQ SYMBOL (IE-READ-FROM-BUFFER BEGIN END 'MAKE-SYMBOL)
		    CHECK :READ)
	      (SETF (SYMBOL-PACKAGE SYMBOL) PACKAGE)))
	(SYS:READ-ERROR))
      (IF (= BEGIN 1) (RETURN))
      (DECF BEGIN 2))
    (IF (NOT CHECK) (IE-BARF))
    (IE-DISPLAY-INFO (IGNORE IGNORE SYMBOL CHECK)
      (LET ((PACKAGE *INPUT-EDITOR-PACKAGE*) relstart)
	(cond
	  ((memq CHECK '(:function-like :both))
	   (zwei:print-arglist
	     (IF MESSAGE-P (FLAVOR:FIND-GENERIC-FUNCTION SYMBOL) SYMBOL)
	     self)))
	(cond
	  ((memq check '(:relation-like :both))
	   (cond ((eq check :both) (format self "~%")))
	   (cond
	     ((memq symbol ap5::*update-macro-list*)
	      ;symbol is an update macro, hopefully followed by a relation name
	      ;(the update macro is :function-like so its own arglist has been output)
	      (cond
		 ((null END)
		  ;already at end of typein, so nothing more to read
		  )
		 ((setq relstart (ie-search-forward-alphabetic END))
		  ;read stuff starting at next nonblank and let
		  ;ap5:typeconstraints do work of verifying stuff is a relname
		  (setq symbol (ie-read-from-buffer	;read in stuff
					 relstart
					 (ie-search-char #\space relstart)
					 'intern))
		  (cond
		    ((ap5::relationp symbol)
		     (format self "~S (relation): ~A"
			     symbol
			     (mapcar #'(lambda (x) (if (lisp::consp x ) (car x) x))
				     (ap5::typeconstraints symbol))))
		    ((member symbol '(funcall apply)))
		    ((ap5::cl-type-name symbol)
		     (format self
		       "~S is a Common Lisp type (and so can be used as an AP5 type)"
		       symbol))
		    (t (format self "~S -- unknown relation" symbol))))))
	     ((ap5::cl-type-name symbol)
	      (format self
		"~S is a Common Lisp type (and so can be used as an AP5 type)"
		symbol))
	     (t
	      ;symbol is an ap5 relation name
	      (format self "~S (relation): ~A" symbol (ap5::typeconstraints symbol))))))
	(cond
	  ((not (memq check '(:function-like :relation-like :both)))
	   (format self "Can't find a definition for ~s." symbol)
	   T))))))



(DEFINE-IE-COMMAND DESCRIBE-PARAMETERS (#\CONTROL-SHIFT-A)
  ;derived from DESCRIBE-ARGUMENTS 
  (IE-RELEVANT-FUNCTION-or-message-or-relation))
